--Callback handler due to Pengoros... Many thanks!
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

--Icon Class

Icon=class(Turbine.UI.Control)
function Icon:Constructor(label,dur,col)
	Turbine.UI.Control.Constructor( self )
		
	self.label=label
	self.Duration=dur
	self.Active=false
	self.Start=0
	self.fract=0

	self:SetSize(width,17)
	self:SetMouseVisible(false)
	
	self.Backdrop=Turbine.UI.Control()
		self.Backdrop:SetSize(width,15)
		self.Backdrop:SetBackColor(Turbine.UI.Color(0.5,0,0,0))
		self.Backdrop:SetPosition(0,0)
		self.Backdrop:SetVisible(true)
		self.Backdrop:SetParent(self)
		self.Backdrop:SetMouseVisible(false)

	self.Bar=Turbine.UI.Control()
		self.Bar:SetSize(0,15)
		if col~=nil then
			self.Bar:SetBackColor(col)
		else
			self.Bar:SetBackColor(Turbine.UI.Color(0.5,1,0,0))
		end
		self.Bar:SetPosition(0,0)
		self.Bar:SetVisible(true)
		self.Bar:SetParent(self.Backdrop)
		self.Bar:SetMouseVisible(false)
		
		--Next two lines give the bar a funky backdrop!
		self.Bar:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)		
		self.Bar:SetBackground (0x41007e25)
	
	self.Text=Turbine.UI.Label()
		self.Text:SetParent( self )
		self.Text:SetPosition( 5, 0 )
		self.Text:SetSize( width-5,15 )
		self.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft)
		self.Text:SetFont(Turbine.UI.Lotro.Verdana12)
		self.Text:SetText(label)
		self.Text:SetOutlineColor( Turbine.UI.Color( 0.8,0, 0, 0 ) )
		self.Text:SetFontStyle( Turbine.UI.FontStyle.Outline )
		self.Text:SetMouseVisible(false)
		
	self.Time=Turbine.UI.Label()
		self.Time:SetParent( self )
		self.Time:SetPosition( 0, 0 )
		self.Time:SetSize( width-5,15 )
		self.Time:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight)
		self.Time:SetFont(Turbine.UI.Lotro.Verdana12)
		self.Time:SetText("")
		self.Time:SetOutlineColor( Turbine.UI.Color( 0.8,0, 0, 0 ) )
		self.Time:SetFontStyle( Turbine.UI.FontStyle.Outline )
		self.Time:SetMouseVisible(false)
end

function Icon:Begin()
	self.Start=Turbine.Engine.GetGameTime()
	self:SetWantsUpdates(true)
	self.Active=true
	CheckBox()
end

--Update function for the bar.
function Icon:Update()
	local Time = Turbine.Engine.GetGameTime()
    local elapsed = Time - self.Start
    if (elapsed > self.Duration) then
		self:Stop()
		return
    end
	
	self.time=math.ceil(self.Duration-elapsed)
	self.Time:SetText(math.ceil(self.time))
	
	self.fract=((self.time)/self.Duration)

	self.Bar:SetWidth(self.fract*width)
end

function Icon:Stop()
	self:SetWantsUpdates(false)
	self.Active=self.alwaysshow
	self.Bar:SetWidth(0)
	self.Time:SetText("")
	self.fract=0
	CheckBox()
end

--Checks the contents of the ListBox.

function CheckBox()
	ListBox:ClearItems()
	for i=1,#List do
		if List[i].Icon.Active then
			ListBox:AddItem(List[i].Icon)
		end
	end
	ListBox:SetSize(width,ListBox:GetItemCount()*17+2)
	--Odd bug - hiding then showing the window helps.
	Window:SetVisible(false)
	Window:SetVisible(true)
end

--Chat monitor.

function chatHandler(sender,args)
	if args.ChatType==2 and args.Sender==Player then
		local mess=args.Message
		for i=1,#List do		
			if not List[i].Buff then
				--Table type
				if type(List[i].txt)=="table" then
					for j=1,#List[i].txt do
						if string.find(mess,List[i].txt[j],1,true) then 
							if test(mess,i) then
								List[i].Icon:Begin()
								--List[i].Icon.Text:SetText(List[i].label.." "..extract(mess,List[i].txt[j],i))
							end
						end
					end
				else	
					--single text
					if string.find(mess,List[i].txt,1,true) then 
						if test(mess,i) then
							List[i].Icon:Begin()
							--List[i].Icon.Text:SetText(List[i].label.." "..extract(mess,List[i].txt,i))
						end
					end
				end
			end
		end
	end
end

function extract(mess,txt,i)
	--Attempt to extract the target name
	local start
	local fin	
	
	--Strip out intiail string
	txt=string.sub(mess,string.find(mess,txt,1,true)+string.len(txt)+1)
	
	local k1=string.find(mess,"on ",1,true)
	local k2=string.find(mess,"to ",1,true)
	local k3=string.find(mess,"the ",1,true)
	
	if k2~=nil then start=k2+3 end
	if k1~=nil then start=k1+3 end
	if k3~=nil then start=k3+4 end
	
	k1=string.find(mess,".",1,true)
	k2=string.find(mess,"for ",1,true)
	
	if k2~=nil then fin=k2-4 end
	if k1~=nil then fin=k1-1 end
	
	if start==nil or fin==nil then return "" end
	
	return string.sub(mess,start,fin)
end



function test (mess,i)
	--See if no numbers are allowed in the text
	--Will blow up if the txt is a table.
	if List[i].nonum then
		local k=string.find(mess,List[i].txt)
		if string.find(mess,"%d",k) then return false end
	end
	
	--See if the not-allowed text is there...
	if List[i].nottxt~=nil then
		if string.find(mess,List[i].nottxt,1,true) then return false end
	end
	
	--Otherwise just do it!
	return true
end